%global heketiver 4.0.0
%global gkver     1.1
%global templatedir heketi

Name:		cns-deploy
Version:	%{heketiver}
Release:	18%{?dist}
Summary:        Container-Native Storage deployment tool
License:        ASL 2.0
Provides:       heketi-templates = %{version}-%{release}
Obsoletes:      heketi-templates < %{version}-%{release}
URL:		https://github.com/gluster/gluster-kubernetes
Source0:	https://github.com/gluster/gluster-kubernetes/archive/v%{gkver}.tar.gz

# Patches ported from upstream gluster-kubernetes:
Patch0001:      0001-Add-the-serviceAccount-to-privileged-scc.patch
Patch0002:      0002-Abort-should-not-be-called-on-heketi-failure.patch
Patch0003:      0003-Add-Heketi-admin-and-user-secret-configurable.patch
Patch0004:      0004-Should-not-proceed-if-endpoint-is-none-for-heketi-se.patch
Patch0005:      0005-Syntax-error.patch
Patch0006:      0006-gk-deploy-escape-quotes-inside-quoted-string.patch
Patch0007:      0007-gk-deploy-fix-assignment-of-array-to-string.patch
Patch0008:      0008-gk-deploy-quote-double-variable-expansion-to-prevent.patch
Patch0009:      0009-gk-deploy-replace-legacy-use-of-expr-index-by-proper.patch
Patch0010:      0010-gk-deploy-use-read-r-instead-of-plain-read.patch
Patch0011:      0011-gk-deploy-add-an-empty-line-before-abort.patch
Patch0012:      0012-gk-deploy-use-eval_output-in-abort.patch
Patch0013:      0013-oc-process-v-is-deprecated-use-p-instead.patch
Patch0014:      0014-gk-deploy-Abort-if-the-label-nodes-command-fails.patch
Patch0015:      0015-gk-deploy-simplify-determining-heketi-address-in-oc-.patch
Patch0016:      0016-Revert-gk-deploy-simplify-determining-heketi-address.patch
Patch0017:      0017-don-t-delete-a-secret-that-we-don-t-create.patch
Patch0018:      0018-gk-deploy-only-get-route-when-endpoints-are-valid-in.patch
Patch0019:      0019-gk-deploy-max-wait-time-and-debug-output-for-getting.patch
Patch0020:      0020-gk-deploy-error-out-if-the-copy-job-was-not-found.patch
Patch0021:      0021-gk-deploy-error-out-if-heketi-pod-does-not-show-up.patch
Patch0022:      0022-make-gk-deploy-run-with-openshift-3.4-origin-1.4-aga.patch
Patch0023:      0023-gk-deploy-fix-error-in-check_pods-when-second-argume.patch
Patch0024:      0024-Tuning-the-Liveness-and-Readiness-Probe-options-to-s.patch
Patch0025:      0025-Make-the-node-label-for-gluster-pods-configurable.patch


# CNS-specific patches
Patch1001:      1001-cns-3.5-downstream-server-container.patch
Patch1002:      1002-cns-3.5-downstream-volmanager-container.patch
Patch1003:      1003-cns-3.5-downstream-volmanager-container.patch

Requires:       heketi-client
Requires:	python


%description
%{name} is a tool to facilitate the deployment of a Container-Native Storage
solution using GlusterFS.


%prep
%setup -n gluster-kubernetes-%{gkver}


# upstream gluster-kubernetes patches:
%patch0001 -p1 -b .0001-Add-the-serviceAccount-to-privileged-scc.patch
%patch0002 -p1 -b .0002-Abort-should-not-be-called-on-heketi-failure.patch
%patch0003 -p1 -b .0003-Add-Heketi-admin-and-user-secret-configurable.patch
%patch0004 -p1 -b .0004-Should-not-proceed-if-endpoint-is-none-for-heketi-se.patch
%patch0005 -p1 -b .0005-Syntax-error.patch
%patch0006 -p1 -b .0006-gk-deploy-escape-quotes-inside-quoted-string.patch
%patch0007 -p1 -b .0007-gk-deploy-fix-assignment-of-array-to-string.patch
%patch0008 -p1 -b .0008-gk-deploy-quote-double-variable-expansion-to-prevent.patch
%patch0009 -p1 -b .0009-gk-deploy-replace-legacy-use-of-expr-index-by-proper.patch
%patch0010 -p1 -b .0010-gk-deploy-use-read-r-instead-of-plain-read.patch
%patch0011 -p1 -b .0011-gk-deploy-add-an-empty-line-before-abort.patch
%patch0012 -p1 -b .0012-gk-deploy-use-eval_output-in-abort.patch
%patch0013 -p1 -b .0013-oc-process-v-is-deprecated-use-p-instead.patch
%patch0014 -p1 -b .0014-gk-deploy-Abort-if-the-label-nodes-command-fails.patch
%patch0015 -p1 -b .0015-gk-deploy-simplify-determining-heketi-address-in-oc-.patch
%patch0016 -p1 -b .0016-Revert-gk-deploy-simplify-determining-heketi-address.patch
%patch0017 -p1 -b .0017-don-t-delete-a-secret-that-we-don-t-create.patch
%patch0018 -p1 -b .0018-gk-deploy-only-get-route-when-endpoints-are-valid-in.patch
%patch0019 -p1 -b .0019-gk-deploy-max-wait-time-and-debug-output-for-getting.patch
%patch0020 -p1 -b .0020-gk-deploy-error-out-if-the-copy-job-was-not-found.patch
%patch0021 -p1 -b .0021-gk-deploy-error-out-if-heketi-pod-does-not-show-up.patch
%patch0022 -p1 -b .0022-make-gk-deploy-run-with-openshift-3.4-origin-1.4-aga.patch
%patch0023 -p1 -b .0023-gk-deploy-fix-error-in-check_pods-when-second-argume.patch
%patch0024 -p1 -b .0024-Tuning-the-Liveness-and-Readiness-Probe-options-to-s.patch
%patch0025 -p1 -b .0025-Make-the-node-label-for-gluster-pods-configurable.patch

# CNS-specific patches
%patch1001 -p1 -b .1001-cns-3.5-downstream-server-container.patch
%patch1002 -p1 -b .1002-cns-3.5-downstream-volmanager-container.patch
%patch1003 -p1 -b .1003-cns-3.5-downstream-volmanager-container.patch


sed -i 's#\./ocp-templates#%{_datadir}/%{templatedir}/templates#' deploy/gk-deploy


%install
install -D -p -m 0755 deploy/gk-deploy %{buildroot}%{_bindir}/cns-deploy
install -D -p -m 0644 deploy/ocp-templates/glusterfs-template.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/glusterfs-template.yaml
install -D -p -m 0644 deploy/ocp-templates/heketi-template.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/heketi-template.yaml
install -D -p -m 0644 deploy/ocp-templates/heketi-service-account.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/heketi-service-account.yaml
install -D -p -m 0644 deploy/ocp-templates/deploy-heketi-template.yaml \
  %{buildroot}%{_datadir}/%{templatedir}/templates/deploy-heketi-template.yaml


%files
%license LICENSE
%doc README.md
%{_datadir}/%{templatedir}/templates/*
%{_bindir}/cns-deploy


%changelog
* Tue May 23 2017 Mohamed Ashiq Liyazudeen - 4.0.0-18
- Resolves: #1454752 - Update the rhgs image tag which has the cve fix in rpcbind and libtirpc

* Mon Apr 24 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-17
- Resolves: #1444459 - rebuild cns-deploy to point to new

* Fri Apr 21 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-16
- Resolves: #1444459 - rebuild cns-deploy to point to new
                       rhgs-volmanager-docker and rhgs-server-docker image
- Resolves: #1444460 - cns-deploy should take label as input

* Fri Apr 14 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-15
- Resolves: #1441351 - [Scale Testing] With volumes scaled to 200, gluster
                       pod not coming up post reboot of a node

* Thu Apr 13 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-14
- Resolves: #1442021 - rebuild cns-deploy pointing to rhgs-volmanager image
                       with signed builds

* Fri Apr 07 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-13
- Resolves: #1434673 - cns-deploy throws a fake error after  it has setup
                       heketi successfully
- Resolves: #1437466 - "Error from server (NotFound): secrets
                       "heketi-db-backup" not found" message seen in
                       cns-deploy --abort operation
- Resolves: #1434838 - heketi-cli command returns error post cns deployment
- Resolves: #1440040 - CNS deploy tool should support both OCP 3.4 and OCP 3.5

* Mon Apr 03 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-12
- Resolves: #1434673 - cns-deploy throws a fake error after  it has setup
                       heketi successfully

* Fri Mar 31 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-11
- Resolves: #1409561 - During --abort operation, "--log-file LOG_FILE"
                       doesn't capture all outputs to the log file
- Resolves: #1436838 - -v 'value' deprecated and replaced with -p 'param'
- Resolves: #1433018 - cns-deploy fails to ensure that nodes are properly
                       labeled during cns setup

* Thu Mar 30 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-10
- Resolves: #1434838 - heketi-cli command returns error post cns deployment

* Tue Mar 28 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-9
- Resolves: #1436136 - cns-deploy tool is broken

* Mon Mar 27 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-8
- Resolves: #1434673 - cns-deploy throws a fake error after it
		       has setup heketi successfully

* Fri Mar 24 2017 Ramakrishna Reddy Yekulla <rreddy@redhat.com> - 4.0.0-7
- Resolves: #1430859 - Make heketi credentials a configurable value in CNS
- Resolves: #1434673 - cns-deploy throws a fake error after it
		       has setup heketi successfully


* Tue Mar 21 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-6
- Resolves: #1434055 - cns-deploy tool failed to setup: failed to communicate
                       with heketi service
- Resolves: #1434426 - cns-deploy should not abort if setting up of heketi pod
                       fails

* Tue Mar 21 2017 Raghavendra Talur <rtalur@redhat.com> - 4.0.0-5
- Resolves: #1434242 - Upstream image reference in deploy heketi

* Fri Mar 17 2017 Ramakrishna Reddy Yekulla <rreddy@redhat.com> - 4.0.0-4
- Resolves: #1433260 - cns_deploy command failed: The DeploymentConfig
		       "heketi" is invalid
- Resolves: #1433304 - Rebase cns-deploy to upstream v1.1


* Fri Mar 17 2017 Ramakrishna Reddy Yekulla <rreddy@redhat.com> - 4.0.0-3
- Resolves: #1409561 - During --abort operation, "--log-file LOG_FILE" doesn't
                       capture all outputs to the log file
- Resolves: #1428381 - cns-deploy continues with the deployment even when
                       gluster pods are not ready
- Resolves: #1432459 - Revert the changes introduced in cns-deploy for storing
                       heketi db in kube secret. 

* Mon Feb 27 2017 Ramakrishna Reddy Yekulla <rreddy@redhat.com> - 4.0.0-2
- Resolves: #1408695 - cns-deploy should NOT try to re-configure a working
                       setup and end up aborting the deployment on executing it
                       for the second time
- Resolves: #1409561 - During --abort operation, "--log-file LOG_FILE" doesn't
                       capture all outputs to the log file
- Resolves: #1423372 - Rebase Heketi package to upstream v4

* Fri Feb 24 2017 Ramakrishna Reddy Yekulla <rreddy@redhat.com> - 4.0.0-1
- Resolves:  #1423372 - Rebase Heketi package to upstream v4.
